public class BowlingGame
{
    private int[] roll;
    private int   nextSlot;

    public BowlingGame()
    {
        roll     = new int[21];
        nextSlot = 0;
    }

    public void roll( int r )
    {
        roll[nextSlot] = r;
        nextSlot++;
    }

    public int score()       // This method is complex... Use a Frame object?
    {
        int score   = 0;
        int current = 0;
        int frame;
        for (int i = 0; i < 10; i++)
        {
            if ( isStrike( current ) )
            {
                frame = roll[current] + roll[current+1] + roll[current+2];
                current++;
            }
            else if ( isSpare( current ) )
            {
                frame = roll[current] + roll[current+1] + roll[current+2];
                current += 2;
            }
            else
            {
                frame = roll[current] + roll[current+1];
                current += 2;
            }
            score += frame;
        }
        return score;
    }

    private boolean isStrike( int currentBall )
    {
        return (roll[currentBall] == 10);
    }

    private boolean isSpare( int currentBall )
    {
        return (roll[currentBall] + roll[currentBall+1] == 10);
    }
}
